﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using DoubleDeckerBus.DrawningObjects;

namespace DoubleDeckerBus.MovementStrategy
{
    public class DrawningObjectBus : IMoveableObject
    {
        private readonly DrawningBus? _drawningBus = null;
        public DrawningObjectBus(DrawningBus drawningBus)
        {
            _drawningBus = drawningBus;
        }
        public ObjectParameters? GetObjectPosition
        {
            get
            {
                if (_drawningBus == null || _drawningBus.EntityBus == null)
                {
                    return null;
                }
                return new ObjectParameters(_drawningBus.GetPosX,
                _drawningBus.GetPosY, _drawningBus.GetWidth, _drawningBus.GetHeight);
            }
        }

        public int GetStep => (int)(_drawningBus?.EntityBus?.Step ?? 0);

        public bool CheckCanMove(DirectionBus direction) =>
        _drawningBus?.CanMove(direction) ?? false;

        public void MoveObject(DirectionBus direction) =>
        _drawningBus?.MoveTransport(direction);
    }
}

